<a id="mypy-boto3-network-firewall"></a>

# mypy-boto3-network-firewall

[![PyPI - types-aiobotocore-network-firewall](https://img.shields.io/pypi/v/types-aiobotocore-network-firewall.svg?color=blue)](https://pypi.org/project/types-aiobotocore-network-firewall)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-network-firewall.svg?color=blue)](https://pypi.org/project/types-aiobotocore-network-firewall)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-network-firewall?color=blue)](https://pypistats.org/packages/types-aiobotocore-network-firewall)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.NetworkFirewall 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/network-firewall.html#NetworkFirewall)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-network-firewall docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_network_firewall/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-network-firewall](#mypy-boto3-network-firewall)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `NetworkFirewall`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `NetworkFirewall` service.

```bash
python -m pip install types-aiobotocore[network-firewall]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[network-firewall]` in your environment:
  `python -m pip install 'types-aiobotocore[network-firewall]'`

Both type checking and auto-complete should work for `NetworkFirewall` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[network-firewall]` in your environment:
  `python -m pip install 'types-aiobotocore[network-firewall]'`

Both type checking and auto-complete should work for `NetworkFirewall` service.
No explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[network-firewall]` in your environment:
  `python -m pip install 'types-aiobotocore[network-firewall]'`
- Run `mypy` as usual

Type checking should work for `NetworkFirewall` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[network-firewall]` in your environment:
  `python -m pip install 'types-aiobotocore[network-firewall]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `NetworkFirewall` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`NetworkFirewallClient` provides annotations for
`session.create_client("network-firewall")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_network_firewall import NetworkFirewallClient

session = get_session()
with async session.create_client("network-firewall") as client:
    client: NetworkFirewallClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_network_firewall.paginator` module contains type annotations
for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_network_firewall import NetworkFirewallClient
from types_aiobotocore_network_firewall.paginator import (
    ListFirewallPoliciesPaginator,
    ListFirewallsPaginator,
    ListRuleGroupsPaginator,
    ListTagsForResourcePaginator,
)

session = get_session()
with async session.create_client("network-firewall") as client:
    client: NetworkFirewallClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_firewall_policies_paginator: ListFirewallPoliciesPaginator = client.get_paginator("list_firewall_policies")
        list_firewalls_paginator: ListFirewallsPaginator = client.get_paginator("list_firewalls")
        list_rule_groups_paginator: ListRuleGroupsPaginator = client.get_paginator("list_rule_groups")
        list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
    ```







### Literals

`types_aiobotocore_network_firewall.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_network_firewall.literals import (
    AttachmentStatusType,
    ConfigurationSyncStateType,
    FirewallStatusValueType,
    GeneratedRulesTypeType,
    ListFirewallPoliciesPaginatorName,
    ListFirewallsPaginatorName,
    ListRuleGroupsPaginatorName,
    ListTagsForResourcePaginatorName,
    LogDestinationTypeType,
    LogTypeType,
    OverrideActionType,
    PerObjectSyncStatusType,
    ResourceManagedStatusType,
    ResourceStatusType,
    RuleGroupTypeType,
    RuleOrderType,
    StatefulActionType,
    StatefulRuleDirectionType,
    StatefulRuleProtocolType,
    TCPFlagType,
    TargetTypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: AttachmentStatusType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_network_firewall.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_network_firewall.type_defs import (
    ActionDefinitionTypeDef,
    AddressTypeDef,
    AssociateFirewallPolicyRequestRequestTypeDef,
    AssociateFirewallPolicyResponseTypeDef,
    AssociateSubnetsRequestRequestTypeDef,
    AssociateSubnetsResponseTypeDef,
    AttachmentTypeDef,
    CreateFirewallPolicyRequestRequestTypeDef,
    CreateFirewallPolicyResponseTypeDef,
    CreateFirewallRequestRequestTypeDef,
    CreateFirewallResponseTypeDef,
    CreateRuleGroupRequestRequestTypeDef,
    CreateRuleGroupResponseTypeDef,
    CustomActionTypeDef,
    DeleteFirewallPolicyRequestRequestTypeDef,
    DeleteFirewallPolicyResponseTypeDef,
    DeleteFirewallRequestRequestTypeDef,
    DeleteFirewallResponseTypeDef,
    DeleteResourcePolicyRequestRequestTypeDef,
    DeleteRuleGroupRequestRequestTypeDef,
    DeleteRuleGroupResponseTypeDef,
    DescribeFirewallPolicyRequestRequestTypeDef,
    DescribeFirewallPolicyResponseTypeDef,
    DescribeFirewallRequestRequestTypeDef,
    DescribeFirewallResponseTypeDef,
    DescribeLoggingConfigurationRequestRequestTypeDef,
    DescribeLoggingConfigurationResponseTypeDef,
    DescribeResourcePolicyRequestRequestTypeDef,
    DescribeResourcePolicyResponseTypeDef,
    DescribeRuleGroupMetadataRequestRequestTypeDef,
    DescribeRuleGroupMetadataResponseTypeDef,
    DescribeRuleGroupRequestRequestTypeDef,
    DescribeRuleGroupResponseTypeDef,
    DimensionTypeDef,
    DisassociateSubnetsRequestRequestTypeDef,
    DisassociateSubnetsResponseTypeDef,
    FirewallMetadataTypeDef,
    FirewallPolicyMetadataTypeDef,
    FirewallPolicyResponseTypeDef,
    FirewallPolicyTypeDef,
    FirewallStatusTypeDef,
    FirewallTypeDef,
    HeaderTypeDef,
    IPSetTypeDef,
    ListFirewallPoliciesRequestRequestTypeDef,
    ListFirewallPoliciesResponseTypeDef,
    ListFirewallsRequestRequestTypeDef,
    ListFirewallsResponseTypeDef,
    ListRuleGroupsRequestRequestTypeDef,
    ListRuleGroupsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    LogDestinationConfigTypeDef,
    LoggingConfigurationTypeDef,
    MatchAttributesTypeDef,
    PaginatorConfigTypeDef,
    PerObjectStatusTypeDef,
    PortRangeTypeDef,
    PortSetTypeDef,
    PublishMetricActionTypeDef,
    PutResourcePolicyRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    RuleDefinitionTypeDef,
    RuleGroupMetadataTypeDef,
    RuleGroupResponseTypeDef,
    RuleGroupTypeDef,
    RuleOptionTypeDef,
    RuleVariablesTypeDef,
    RulesSourceListTypeDef,
    RulesSourceTypeDef,
    StatefulEngineOptionsTypeDef,
    StatefulRuleGroupOverrideTypeDef,
    StatefulRuleGroupReferenceTypeDef,
    StatefulRuleOptionsTypeDef,
    StatefulRuleTypeDef,
    StatelessRuleGroupReferenceTypeDef,
    StatelessRuleTypeDef,
    StatelessRulesAndCustomActionsTypeDef,
    SubnetMappingTypeDef,
    SyncStateTypeDef,
    TCPFlagFieldTypeDef,
    TagResourceRequestRequestTypeDef,
    TagTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateFirewallDeleteProtectionRequestRequestTypeDef,
    UpdateFirewallDeleteProtectionResponseTypeDef,
    UpdateFirewallDescriptionRequestRequestTypeDef,
    UpdateFirewallDescriptionResponseTypeDef,
    UpdateFirewallPolicyChangeProtectionRequestRequestTypeDef,
    UpdateFirewallPolicyChangeProtectionResponseTypeDef,
    UpdateFirewallPolicyRequestRequestTypeDef,
    UpdateFirewallPolicyResponseTypeDef,
    UpdateLoggingConfigurationRequestRequestTypeDef,
    UpdateLoggingConfigurationResponseTypeDef,
    UpdateRuleGroupRequestRequestTypeDef,
    UpdateRuleGroupResponseTypeDef,
    UpdateSubnetChangeProtectionRequestRequestTypeDef,
    UpdateSubnetChangeProtectionResponseTypeDef,
)

def get_structure() -> ActionDefinitionTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-network-firewall` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Documentation

All type annotations can be found in
[types-aiobotocore-network-firewall docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_network_firewall/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
